package com.example.apitest.API

import com.google.gson.Gson
import com.google.gson.GsonBuilder
import com.google.gson.JsonObject
import retrofit2.Call
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory
import retrofit2.create
import retrofit2.http.Body
import retrofit2.http.GET
import retrofit2.http.Header
import retrofit2.http.POST

data class News(
    var id : Int,
    var name : String?,
    var description : String?,
    var price : Int,
    var image : String?
)

data class Catalog(
    var id : Int,
    var name : String?,
    var description : String?,
    var price : Int,
    var category : String?,
    var timeResul : String?,
    var preparation : String?,
    var bio : String?
)

data class Order(
    var id : Int,
    var address : String?,
    var dataTimeOder : String?,
    var phone : String?,
    var comment : String?,
    var catalogs : MutableCollection<Catalog>
)

data class User(
    var id : Int,
    var username : String,
    var firstName : String,
    var lastName : String,
    var email : String,
    var password : String,
    var phone : String,
    var userStatus : Int
)

interface ApiInterface {

    @GET("api/News")
    public fun GetAllNews() : Call<MutableList<News>>

    @POST("api/Order")
    public fun PostOrder(@Body order : Order, @Header("Authorization") bearer : String) : Call<Int>

    @GET("api/Order")
    public fun GetOrder(@Header("Authorization") bearer : String) : Call<MutableList<Order>>

}

interface ApiInterfaceMain {

    @POST("user")
    public fun PostUser(@Body user : User) : Call<JsonObject>

}

object APIConnection {
    public val apiBearer : String = "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJlbWFpbCI6Im1lc2VyeWdhbWVyQGdtYWlsLmNvbSIsIkRhdGUiOiIxMC4xMi4yMDIzIDIyOjIwOjA4IiwianRpIjoiZjIxOGVkNTgtMTU4ZS00MDRiLWE1YjgtNTkxOGQwMTI5NWQwIiwiZXhwIjoxNzA0ODI4MDA4LCJpc3MiOiJNeUF1dGhTZXJ2ZXIiLCJhdWQiOiJNeUF1dGhDbGllbnQifQ.85Gmp3X33X1q1BtQj1ewIWrhFjunK_4Ks0OlimgyD_g";

    fun getRetrofit() : ApiInterface
    {
        return Retrofit.Builder()
                       .baseUrl("https://iis.ngknn.ru/NGKNN/%D0%9C%D0%B0%D0%BC%D1%88%D0%B5%D0%B2%D0%B0%D0%AE%D0%A1/MedicMadlab/")
                       .addConverterFactory(GsonConverterFactory.create(GsonBuilder().setDateFormat("yyyy-MM-dd'T'HH:mm:ss").setLenient().create()))
                       .build().create(ApiInterface::class.java)
    }
}

object APIConnectionMain {
    fun getRetrofit() : ApiInterfaceMain
    {
        return Retrofit.Builder()
            .baseUrl("https://petstore.swagger.io/v2/")
            .addConverterFactory(GsonConverterFactory.create(GsonBuilder().setDateFormat("yyyy-MM-dd'T'HH:mm:ss").setLenient().create()))
            .build().create(ApiInterfaceMain::class.java)
    }
}

/*
object APIConnection {

    private var service : Retrofit? = null;

    var gson = GsonBuilder().setLenient().create()

    var URL : String = "https://iis.ngknn.ru/NGKNN/%D0%9C%D0%B0%D0%BC%D1%88%D0%B5%D0%B2%D0%B0%D0%AE%D0%A1/MedicMadlab/";

    fun getService() : Retrofit
    {
        if(service == null)
        {
            service = Retrofit.Builder()
                              .baseUrl(URL)
                              .addConverterFactory(GsonConverterFactory.create(gson))
                              .build()
            return service!!;
        }
        return service!!;
    }

}

object APIWithInterface{

    fun GetAPIWithInterface() : ApiInterface
    {
        return APIConnection.getService().create(ApiInterface::class.java)
    }

}*/